from pdf2image import convert_from_path
from detecta import detect_peaks
from fastapi.responses import JSONResponse
from fastapi import FastAPI, APIRouter,File, UploadFile,status
from PIL import Image
from fpdf import FPDF
import pandas as pd
import collections
import datetime
import numpy as np
import pytesseract
import statistics
import textwrap
import os.path
import fnmatch
import logging
import PyPDF2
import math
import random,string
import time
import base64
from fastapi import APIRouter
import cv2
import DataModel.models as models
from DataModel import db, session


logging.basicConfig(filename="log.txt", level=logging.DEBUG,
                    format="%(asctime)s %(message)s", filemode="w")

start_time = str(int(time.time())+int(''.join(random.choice(string.digits) for _ in range(1))))

class CtgiReport:
    """initialization of class variables and lists"""
    paper_speed = 1
    deviation = 15
    page_speed = 20 / paper_speed
    patient_id = 0
    data = 0
    dec_count = 0
    late_dec_count = 0
    var_dec_count = 0
    var_early_count = 0
    pro_dec_count = 0
    late_deccount = 0
    var_deccount = 0
    pro_deccount = 0
    var_earlycount = 0
    max_value = 0
    min_value = 0
    avg_mean = 0
    Acc_total_count = 0
    Dec_total_count = 0
    patient_name = ""
    bhr_type = ""
    Date = ""
    Time = ""
    text = ""
    Report_Ctg = ""
    Output_variability = []
    Montevideo_list = []
    Time_c = []
    Contractions = []
    Time_f = []
    Fetal_rate = []
    Time_list = []
    heart_rate_list = []
    indexes = []
    dummy_list = []
    fetal_time = []
    bhr_time_acc_10 = []
    bhr_time_dec_10 = []
    dummy_fetal_10 = []
    dummy_time_10 = []
    bhr_time_acc = []
    bhr_time_dec = []
    fetal_dummy = []
    time_dummy = []
    fetal_dec = []
    fetal_data = []
    time_data = []
    peak_value = []
    contraction_b_10 = []
    dummy_contraction_10 = []
    dummy_time_c_10 = []
    contraction_time = []
    df_1 = pd.DataFrame()
    df_2 = pd.DataFrame()
    df_3 = pd.DataFrame()
    inputpdf = ''
    path_cwd = ''
    path = ''

    def __init__(self, user_id, file_path):
        self.user_id = user_id
        self.file_path = file_path

    #################################################################
    # For Getting the path of input pdf from the package            #
    #################################################################

    def Pdf_path(self):
        self.path_cwd = os.getcwd()
        self.path = self.path_cwd.split("\\")
        self.path = '\\\\'.join(self.path[0:len(self.path)])
        self.inputpdf = PyPDF2.PdfFileReader(self.file_path, "rb")
        return self.inputpdf

    ##############################################################################################
    #    To extract X and Y- coordinates from contraction and fetal graphs respectively          #
    ##############################################################################################

    def ImageCrop(self, name, iter, left, top_c, right, bottom_c, top_f, bottom_f):
        img = Image.open(name)

        # for cropping fetal graph
        img_res = img.crop((left, top_c, right, bottom_c))
        img_res.save("fetal_"+start_time+".jpg", 'JPEG')
        # for cropping contractions graph

        img_res = img.crop((left, top_f, right, bottom_f))
        img_res.save("contraction"+start_time+".jpg", 'JPEG')
        # For extracting X - coordinates and y - coordinates for contraction graph

        imag = cv2.imread("contraction"+start_time+".jpg")
        imag = cv2.cvtColor(imag, cv2.COLOR_RGB2GRAY)
        width, height = imag.shape
        x_scale = height / self.page_speed
        scale_factor = round(width / 100, 2)

        threshold_level = 80

        # To get coordinates of all pixels below threshold

        data_c = np.column_stack(np.where(imag < threshold_level))
        data_c = data_c[data_c[:, 1].argsort()]
        df = pd.DataFrame(data_c, columns=["Y", "X"])
        for i in range(len(df["X"])):
            self.Contractions.append(round((width - df["Y"][i]) / scale_factor, 2))
            self.Time_c.append(round(df["X"][i] / x_scale, 2) + (self.page_speed * iter))

        # For extracting X - coordinates and y - coordinates for contraction graph
        imag = cv2.imread("fetal_"+start_time+".jpg")
        imag = cv2.cvtColor(imag, cv2.COLOR_RGB2GRAY)
        width, height = imag.shape
        x_scale = height / self.page_speed
        scale_factor = round(width / 150, 2)

        threshold_level = 97

        # To get coordinates of all pixels below threshold

        data_f = np.column_stack(np.where(imag < threshold_level))
        data_f = data_f[data_f[:, 1].argsort()]
        df = pd.DataFrame(data_f, columns=["Y", "X"])
        for i in range(len(df["X"])):
            self.Fetal_rate.append(round(((width - df["Y"][i] + 60 * scale_factor) / scale_factor), 2))
            self.Time_f.append(round(df["X"][i] / x_scale, 2) + (self.page_speed * iter))
        os.remove("fetal_"+start_time+".jpg")
        os.remove("contraction"+start_time+".jpg")
        return self.Contractions,self.Time_c,self.Fetal_rate,self.Time_f

    ##############################################################################################
    #     For converting Input PDF to image and For extracting the text data from Input          #
    ##############################################################################################

    def Pdf_To_Image(self):
        inputpdf = self.Pdf_path()
        for i in range(inputpdf.numPages):
            output = PyPDF2.PdfFileWriter()
            output.addPage(inputpdf.getPage(i))
            with open("document-page%s.pdf" % start_time, "wb") as outputStream:
                output.write(outputStream)
            images = convert_from_path('document-page' + start_time + '.pdf', size=(1250, 1250), grayscale=True)
            for k in range(len(images)):
                # Save pages as images in the pdf
                images[k].save('integrated' + start_time + '.jpg', 'JPEG')

            if i == 0:
                images_verification = convert_from_path('document-page' + start_time + '.pdf', grayscale=True)
                for k in range(len(images_verification)):

                    # Save pages as images in the pdf

                    images_verification[k].save('integrated' + start_time + '.png', 'PNG')
                    img = Image.open('integrated' + start_time + '.png')

                    # for cropping Text portion from image

                    img_res = img.crop((100, 67, 1500, 4000))
                    img_res.save('integrated' + start_time + '.png', 'PNG')
                    img = Image.open('integrated' + start_time + '.png')

                    # path where the tesseract module is installed
                    pytesseract.pytesseract.tesseract_cmd = self.path_cwd + "\\Endpoints\\Tesseract-OCR\\tesseract.exe"

                    # converts the image to result and saves it into result variable

                    result = pytesseract.image_to_string(img)
                    os.remove('integrated' + start_time + '.png')


                    # write text in a text file and save it to source path

                    with open('output'+start_time+'.txt', mode='w') as file:
                        file.write(result)

                    text = []
                    with open('output'+start_time+'.txt') as f:
                        for line in f:
                            if not (line.isspace()):
                                text.append(line.strip())

                    # Iterate over the lines of the File

                    elem = 'Patient Id :'
                    elem1 = 'Mother :'
                    elem2 = 'Time : '
                    elem3 = 'Date : '

                    # Find index position of first occurrence elem in the list
                    if elem not in text:
                        self.patient_id = "No_ID"
                    else:

                        index_pos = text.index(elem)
                        self.patient_id = text[index_pos + 1].split()[0]
                        only_num = ''
                        if text[index_pos + 1].isnumeric():
                            self.patient_id = text[index_pos + 1]
                        else:
                            for char in text[index_pos + 1]:
                                if char.isnumeric():
                                    only_num += char
                                    self.patient_id = str(only_num)

                        if self.patient_id == "Mother":
                            self.patient_id = "No_ID"
                    if elem1 not in text:
                        self.patient_name = "No_Name"
                    else:
                        index_pos = text.index(elem1)
                        only_alpha = ''
                        if text[index_pos + 1].isalpha():
                            self.patient_name = text[index_pos + 1]
                        else:
                            for char in text[index_pos + 1]:
                                only_alpha += char
                                self.patient_name = only_alpha
                        self.Time = text[index_pos + 3].split(elem2)[1]
                        self.Date = text[index_pos + 4].split(elem3)[1]
                    os.remove('output'+start_time+'.txt')

            # For cropping the fetal and contraction graphs
            os.remove('document-page' + start_time + '.pdf')
            self.ImageCrop('integrated' + start_time + '.jpg', i, 317.5, 83.75, 1237.5, 585, 718.75, 1051.25)
            os.remove('integrated' + start_time + '.jpg')
            if i == self.inputpdf.numPages-1:
                # Create DataFrame from multiple lists
                d1 = {'Fetal rate': self.Fetal_rate, 'Time_F(sec)': self.Time_f}
                self.df_1 = pd.DataFrame(d1)
                d2 = {'Contraction':self.Contractions,'Time_C(sec)':self.Time_c}
                self.df_2 = pd.DataFrame(d2)
                self.data = self.df_1["Time_F(sec)"][len(self.df_1["Time_F(sec)"]) - 1]

    def Read_Excel_Data(self):

        page_num = self.inputpdf.numPages
        df_f = pd.read_excel('Fetal_NST_data' + str(page_num - 1) + '.xlsx')
        column_names = ["Fetal rate", "Time_F(sec)"]
        self.df_1 = pd.DataFrame(df_f, columns=column_names)
        df_c = pd.read_excel('Contraction_NST_data' + str(page_num - 1) + '.xlsx')
        column_names = ["Contraction", "Time_C(sec)"]
        self.df_2 = pd.DataFrame(df_c, columns=column_names)
        self.data = self.df_1["Time_F(sec)"][len(self.df_1["Time_F(sec)"]) - 1]

    ##########################################
    # for finding the montevideo units count #
    ##########################################

    def montevideo_count(self, start_range, end_range):
        del self.peak_value[:]
        del self.contraction_b_10[:]
        del self.dummy_contraction_10[:]
        del self.dummy_time_c_10[:]

        for i in range(0, len(self.df_2["Time_C(sec)"]) - 1):
            if start_range <= self.df_2["Time_C(sec)"][i] < end_range:
                self.dummy_contraction_10.append(self.df_2["Contraction"][i])
                self.dummy_time_c_10.append(self.df_2["Time_C(sec)"][i])
            else:
                continue

        index = detect_peaks(self.dummy_contraction_10)
        for i in index:
            self.peak_value.append(self.dummy_contraction_10[i])
        peak_value_greater_20 = []
        for i in index:
            if self.dummy_contraction_10[i] > 20:
                peak_value_greater_20.append(self.dummy_contraction_10[i])
        list = []
        sum1 = 0
        count = 0
        for l in self.peak_value:
            if l > 20:
                list.append(l)
            else:
                if len(list) != 0:
                    count = count + 1
                    sum1 = sum1 + max(list) - 20
                    sum1 = math.floor(sum1)
                    list.clear()
        return sum1

    # To Find the BHR Type

    def get_bhr_type(self, Mean):
        if 160 > Mean > 110:
            self.bhr_type = "Normal BHR"
        elif Mean >= 160:
            self.bhr_type = "Fetal tachycardia"
        else:
            self.bhr_type = "Fetal bradycardia"
        return self.bhr_type

    # To Find the BHR,Acceleration and Deceleration for every 10 min interval

    def bhr_for_interval(self, start_range, end_range):
        del self.dummy_fetal_10[:]
        del self.dummy_time_10[:]
        for i in range(0, len(self.df_1["Time_F(sec)"]) - 1):
            if start_range <= self.df_1["Time_F(sec)"][i] < end_range:
                self.dummy_fetal_10.append(self.df_1["Fetal rate"][i])
                self.dummy_time_10.append(self.df_1["Time_F(sec)"][i])
            else:
                continue
        mean_1 = statistics.mean(self.dummy_fetal_10)
        acc_10 = self.get_acceleration_count_10(self.dummy_fetal_10, self.dummy_time_10, mean_1)
        dec_10 = self.get_deceleration_count_10(self.dummy_fetal_10, self.dummy_time_10, mean_1)
        del self.fetal_dummy[:]
        del self.time_dummy[:]
        for i in range(0, len(self.dummy_fetal_10) - 1):
            if self.dummy_time_10[i] not in acc_10 and self.dummy_time_10[i] not in dec_10:
                self.fetal_dummy.append(self.dummy_fetal_10[i])
                self.time_dummy.append(self.dummy_time_10[i])
            else:
                continue
        mean_inter = statistics.mean(self.fetal_dummy)
        del self.fetal_dummy[:]
        del self.time_dummy[:]
        acceleration_count, acc = self.get_acceleration_counts(self.dummy_fetal_10, self.dummy_time_10, int(mean_inter))
        dec_fetal, deceleration_count, dec = self.get_deceleration_counts(self.dummy_fetal_10, self.dummy_time_10,
                                                                          int(mean_inter))
        for i in range(0, len(self.dummy_fetal_10) - 1):
            if self.dummy_time_10[i] not in acc and self.dummy_time_10[i] not in dec:
                self.fetal_dummy.append(self.dummy_fetal_10[i])
                self.time_dummy.append(self.dummy_time_10[i])
            else:
                continue
        self.fetal_data.extend(self.fetal_dummy)
        self.time_data.extend(self.time_dummy)
        self.fetal_dec.extend(dec_fetal)
        return mean_inter, acceleration_count, deceleration_count, self.fetal_dec

    def get_acceleration_count_10(self, dummy_fetal, dummy_time, mean_a):
        del self.bhr_time_acc_10[:]
        if len(self.fetal_time) != 0:
            del self.fetal_time[:]
            del self.heart_rate_list[:]
            del self.Time_list[:]
        for i in range(0, len(dummy_fetal) - 1):
            if int(dummy_fetal[i]) >= mean_a:
                if len(self.Time_list) == 0:
                    self.Time_list.append(dummy_time[i])
                    self.heart_rate_list.append(dummy_fetal[i])
                else:
                    if self.Time_list[-1] == dummy_time[i - 1]:
                        self.Time_list.append(dummy_time[i])
                        self.heart_rate_list.append(dummy_fetal[i])
                    else:
                        del self.Time_list[:]
                        del self.heart_rate_list[:]

            else:

                if len(self.heart_rate_list) > 2:

                    if (self.Time_list[-1] - self.Time_list[0]) >= 0.25 and max(self.heart_rate_list) >= mean_a + 15:
                        self.bhr_time_acc_10.extend(self.Time_list)
                        d_list = self.heart_rate_list
                        trail = d_list.index(max(d_list))
                        self.fetal_time.append(round(self.Time_list[trail], 2))
                        del self.Time_list[:]
                        del self.heart_rate_list[:]
                else:
                    del self.Time_list[:]
                    del self.heart_rate_list[:]
        if len(self.heart_rate_list) > 2:
            if (self.Time_list[-1] - self.Time_list[0]) >= 0.25 and max(self.heart_rate_list) >= mean_a + 15:
                self.bhr_time_acc_10.extend(self.Time_list)
                d_list = self.heart_rate_list
                trail = d_list.index(max(d_list))
                self.fetal_time.append(round(self.Time_list[trail], 2))
                del self.Time_list[:]
                del self.heart_rate_list[:]
            else:
                del self.Time_list[:]
                del self.heart_rate_list[:]
        return self.bhr_time_acc_10

    def get_deceleration_count_10(self, dummy_fetal, dummy_time, mean_d):
        del self.bhr_time_dec_10[:]
        if len(self.fetal_time) != 0:
            del self.fetal_time[:]
            del self.heart_rate_list[:]
            del self.Time_list[:]
        for i in range(0, len(dummy_fetal) - 1):
            if int(dummy_fetal[i]) <= mean_d:
                if len(self.Time_list) == 0:
                    self.Time_list.append(dummy_time[i])
                    self.heart_rate_list.append(dummy_fetal[i])
                else:
                    if self.Time_list[-1] == dummy_time[i - 1]:
                        self.Time_list.append(dummy_time[i])
                        self.heart_rate_list.append(dummy_fetal[i])
                    else:
                        del self.Time_list[:]
                        del self.heart_rate_list[:]

            else:
                if len(self.heart_rate_list) > 2:
                    if (self.Time_list[-1] - self.Time_list[0]) >= 0.25 and min(self.heart_rate_list) <= mean_d - 15:
                        self.bhr_time_dec_10.extend(self.Time_list)
                        d_list = self.heart_rate_list
                        trail = d_list.index(max(d_list))
                        self.fetal_time.append(round(self.Time_list[trail], 2))
                        del self.Time_list[:]
                        del self.heart_rate_list[:]
                else:
                    del self.Time_list[:]
                    del self.heart_rate_list[:]
        if len(self.heart_rate_list) > 2:
            if (self.Time_list[-1] - self.Time_list[0]) >= 0.25 and min(self.heart_rate_list) <= mean_d - 15:
                self.bhr_time_dec_10.extend(self.Time_list)
                d_list = self.heart_rate_list
                trail = d_list.index(max(d_list))
                self.fetal_time.append(round(self.Time_list[trail], 2))
                del self.Time_list[:]
                del self.heart_rate_list[:]
            else:
                del self.Time_list[:]
                del self.heart_rate_list[:]
        return self.bhr_time_dec_10

    def get_acceleration_counts(self, dummy_fetal, dummy_time, mean_1):
        del self.bhr_time_acc[:]
        if len(self.fetal_time) != 0:
            del self.fetal_time[:]
            del self.heart_rate_list[:]
            del self.Time_list[:]
        for i in range(0, len(dummy_fetal) - 1):
            if math.ceil(dummy_fetal[i]) >= mean_1:
                if len(self.Time_list) == 0:
                    self.Time_list.append(dummy_time[i])
                    self.heart_rate_list.append(math.ceil(dummy_fetal[i]))
                else:
                    if self.Time_list[-1] == dummy_time[i - 1]:
                        self.Time_list.append(dummy_time[i])
                        self.heart_rate_list.append(math.ceil(dummy_fetal[i]))
                    else:
                        del self.Time_list[:]
                        del self.heart_rate_list[:]
            else:
                if len(self.heart_rate_list) > 2:
                    if (self.Time_list[-1] - self.Time_list[0]) >= 0.25 and max(self.heart_rate_list) >= mean_1 + 15:
                        self.bhr_time_acc.extend(self.Time_list)
                        dummy_h_a = self.heart_rate_list
                        trail = dummy_h_a.index(max(dummy_h_a))
                        # print("Acceleration occurs at", self.Time_list[trail], "with time deviation of",
                        #       (self.Time_list[-1] - self.Time_list[0]) * 60, " seconds")
                        self.fetal_time.append(round(self.Time_list[trail], 2))
                        del self.Time_list[:]
                        del self.heart_rate_list[:]
                else:
                    del self.Time_list[:]
                    del self.heart_rate_list[:]
        if len(self.heart_rate_list) > 2:
            if (self.Time_list[-1] - self.Time_list[0]) >= 0.25 and max(self.heart_rate_list) >= mean_1 + 15:
                self.bhr_time_acc.extend(self.Time_list)
                dummy_h_a = self.heart_rate_list
                trail = dummy_h_a.index(max(dummy_h_a))
                # print("Acceleration occurs at", self.Time_list[trail], "with time deviation of",
                #       (self.Time_list[-1] - self.Time_list[0]) * 60, " seconds")
                self.fetal_time.append(round(self.Time_list[trail], 2))
                del self.Time_list[:]
                del self.heart_rate_list[:]
            else:
                del self.Time_list[:]
                del self.heart_rate_list[:]
        return len(self.fetal_time), self.bhr_time_acc

    def get_deceleration_counts(self, dummy_fetal, dummy_time, mean_1):
        del self.bhr_time_dec[:]
        if len(self.fetal_time) != 0:
            del self.fetal_time[:]
            del self.heart_rate_list[:]
            del self.Time_list[:]
        for i in range(0, len(dummy_fetal) - 1):
            if int(dummy_fetal[i]) <= mean_1:
                if len(self.Time_list) == 0:
                    self.Time_list.append(dummy_time[i])
                    self.heart_rate_list.append(dummy_fetal[i])
                else:
                    if self.Time_list[-1] == dummy_time[i - 1]:
                        self.Time_list.append(dummy_time[i])
                        self.heart_rate_list.append(dummy_fetal[i])
                    else:
                        del self.Time_list[:]
                        del self.heart_rate_list[:]
            else:
                if len(self.heart_rate_list) > 2:
                    if (self.Time_list[-1] - self.Time_list[0]) >= 0.25 and min(self.heart_rate_list) <= int(
                            mean_1 - 15):
                        self.bhr_time_dec.extend(self.Time_list)
                        dummy_h_d = self.heart_rate_list
                        trail = dummy_h_d.index(min(dummy_h_d))
                        # print("Deceleration occurs at", self.Time_list[trail], "with time deviation of",
                        #       (self.Time_list[-1] - self.Time_list[0]) * 60, " seconds")

                        self.fetal_time.append(round(self.Time_list[trail], 2))
                        del self.Time_list[:]
                        del self.heart_rate_list[:]
                else:
                    del self.Time_list[:]
                    del self.heart_rate_list[:]
        if len(self.heart_rate_list) > 2:
            if (self.Time_list[-1] - self.Time_list[0]) >= 0.25 and min(self.heart_rate_list) <= mean_1 - 15:
                self.bhr_time_dec.extend(self.Time_list)
                dummy_h_d = self.heart_rate_list
                trail = dummy_h_d.index(min(dummy_h_d))
                # print("Deceleration occurs at", self.Time_list[trail], "with time deviation of",
                #       (self.Time_list[-1] - self.Time_list[0]) * 60, " seconds")
                self.fetal_time.append(round(self.Time_list[trail], 2))
                del self.Time_list[:]
                del self.heart_rate_list[:]
            else:
                del self.Time_list[:]
                del self.heart_rate_list[:]
        return self.fetal_time, len(self.fetal_time), self.bhr_time_dec

    def Bhr_For_Interval(self):
        #self.Read_Excel_Data()
        for i in range(int(self.data / 10) + 1):
            mean_1, acc_count, dec_count, fetal_dec = self.bhr_for_interval(i * 10, (i * 10) + 10)
            self.avg_mean = self.avg_mean + mean_1
            self.Montevideo_list.append(self.montevideo_count(i * 10, (i * 10) + 10))
            self.Acc_total_count = self.Acc_total_count + acc_count
            self.Dec_total_count = self.Dec_total_count + dec_count
            # print("BHR FOR INTERVAL", i, ":", mean_1)
        self.avg_mean = math.floor(self.avg_mean / (int(self.data / 10) + 1))
        d = {'fetal_dummy': self.fetal_data, 'time_dummy': self.time_data}
        self.df_3 = pd.DataFrame(d)

    # To find the range of variability

    @staticmethod
    def find_variability(arr):
        elements_count = collections.Counter(arr)
        my_dict = dict(elements_count)
        my_list_tuple = sorted(my_dict.items())[5:]
        mynew_list_tuple = []
        for ele in my_list_tuple:
            if ele[1] == 1:
                my_list_tuple.remove(ele)
            else:
                mynew_list_tuple.append(ele)
        mynew_dict = dict(mynew_list_tuple)
        val = mynew_dict.values()
        # to find total count of ele inside mynew_dict
        total_count = sum(sorted(val))
        # to calculate for 50% of element
        half = total_count / 2
        sor = sorted(mynew_dict.items())
        l1 = []
        l2 = []
        for ele in sor:
            if ele[0] in range(5, 26):
                l1.append(ele)
        mysmall_dict = dict(l1)
        val = mysmall_dict.values()
        small_count = sum(sorted(val))
        for ele in sor:
            if int(ele[0]) > 25:
                l2.append(ele)
        mybig_dict = dict(l2)

        # if 50% of element is from 5-25 range find variability range
        if small_count > half:

            key = mysmall_dict.keys()
            value = mysmall_dict.values()
            sorted_key = sorted(key)
            maxlist = []
            minlist = []
            mav = max(value)
            miv = min(value)
            for i in sorted_key:
                if i > 4:
                    if mysmall_dict[i] == mav:
                        maxlist.append(i)
                    if mysmall_dict[i] == miv:
                        minlist.append(i)
        else:
            key = mybig_dict.keys()
            sorted_key = sorted(key)
            values = mybig_dict.values()
            maxlist = []
            minlist = []
            mav = max(values)
            miv = min(values)
            for i in sorted_key:
                if i > 4:
                    if mybig_dict[i] == mav:
                        maxlist.append(i)
                    if mybig_dict[i] == miv:
                        minlist.append(i)
        return max(maxlist), min(minlist)

    @staticmethod
    def sinusoidal_pattern(minimum_value, maximum_value):
        if maximum_value != 0 and minimum_value != 0:
            if abs(maximum_value - minimum_value) <= 2:
                return True
            else:
                return False
        else:
            return False

    # To find the variability Type

    @staticmethod
    def variability_type(minimum_value, maximum_value):
        if maximum_value == 0 and minimum_value == 0:
            return "Absent Variability"
        elif maximum_value < 5 and minimum_value < 5:
            return "Reduced Variability"
        elif maximum_value <= 25:
            return "Normal Variability"
        else:
            return "Saltatory"

    # For finding the peak and trough values of contraction list

    def variability_peak_trough(self):
        self.Bhr_For_Interval()
        peaks = []
        total = []
        trough_value = []
        troughs = []
        index_value = detect_peaks(self.df_3["fetal_dummy"])
        for i in range(len(self.df_3["fetal_dummy"])):
            total.append(self.df_3["fetal_dummy"][i])
            if i not in index_value:
                trough_value.append(self.df_3["fetal_dummy"][i])
            else:
                troughs.append(min(trough_value))
                del trough_value[:]
        for i in index_value:
            peaks.append(self.df_3["fetal_dummy"][i])
        return peaks, troughs

    def Variability_range(self):
        Peaks, Troughs = self.variability_peak_trough()

        for i in range(min(len(Peaks), len(Troughs))):
            if Peaks[i] > Troughs[i]:
                self.Output_variability.append(int(Peaks[i] - Troughs[i]))
            else:
                self.Output_variability.append(int(Peaks[i]))

    @staticmethod
    def find_min(fetal_trough, list_c):
        for i in range(len(list_c)):
            if list_c[i] >= fetal_trough:
                value = list_c[i - 1]
                return value
            else:
                return list_c[-1]

    # To find the deceleration Type

    def find_deceleration_type(self, Time_F, Time_C):
        self.late_deccount = 0
        self.var_deccount = 0
        self.pro_deccount = 0
        self.var_earlycount = 0
        for i in range(len(Time_F)):
            c_time = self.find_min(Time_F[i], Time_C)
            if (1 / 60) * 10 <= abs(float(Time_F[i] - c_time)) < (1 / 60) * 20:
                self.late_deccount += 1
            elif (1 / 60) * 20 <= Time_F[i] - c_time <= 2.00:
                self.var_deccount += 1
            elif (1 / 60) * 10 > Time_F[i] - c_time >= 0:
                self.var_earlycount += 1
            elif 2.00 < Time_F[i] - c_time <= 10.00:
                self.pro_deccount += 1
            else:
                break
        return self.late_deccount, self.var_deccount, self.var_earlycount, self.pro_deccount

    def final_report(self):
        self.Variability_range()
        final_result = "____________"
        self.max_value, self.min_value = self.find_variability(self.Output_variability)
        self.bhr_type = self.get_bhr_type(self.avg_mean)

        if len(self.fetal_dec) != 0:
            self.peak_value = []
            self.contraction_time = []
            index = detect_peaks(self.df_2["Contraction"])
            for i in index:
                #if self.df_2["Contraction"][i] > 20:
                    self.peak_value.append(self.df_2["Contraction"][i])
                    self.contraction_time.append(self.df_2["Time_C(sec)"][i])
            if len(self.contraction_time)!=0:
               self.late_dec_count, self.var_dec_count, self.var_early_count, self.pro_dec_count = self.find_deceleration_type(
                self.fetal_dec,
                self.contraction_time)

        if (self.bhr_type == "Normal BHR" and self.variability_type(self.min_value,
                                                                    self.max_value) == 'Normal Variability' and (
                    self.late_dec_count == 0 or self.var_dec_count == 0)) or bool(self.Acc_total_count) or bool(
            self.var_early_count):
            final_result = "Normal"
        if self.variability_type(self.min_value, self.max_value) == 'Reduced Variability' and \
                self.bhr_type == "Fetal bradycardia" or bool(self.late_dec_count) or bool(
            self.var_dec_count) or self.sinusoidal_pattern(self.min_value, self.max_value) == "True":
            final_result = "Abnormal"
        if (self.variability_type(self.min_value, self.max_value) != 'Reduced Variability' and (
                self.bhr_type == "Fetal bradycardia" or self.bhr_type == "Fetal tachycardia")) or \
                ((self.variability_type(self.min_value,
                                        self.max_value) == 'Reduced Variability' and self.dec_count != 0) or self.variability_type(
                    self.min_value, self.max_value) == "Saltatory") or \
                (self.Acc_total_count == 0) or (bool(self.var_dec_count) or bool(self.pro_dec_count) or (
                bool(self.late_dec_count) and self.variability_type(self.min_value,
                                                                    self.max_value) == "Normal Variability") or
                                                (bool(self.var_dec_count) and (self.variability_type(self.min_value,
                                                                                                     self.max_value) == "Reduced Variability" or self.variability_type(
                                                    self.min_value, self.max_value) == "Normal Variability"))):
            final_result = "Indeterminate"

        return final_result

    # creating test report

    def Test_Report(self):
        self.Pdf_To_Image()
        self.Report_Ctg = self.final_report()
        self.text = self.Report_Ctg +start_time+ ".txt"
        with open(self.text, "w") as f:
            f.write("\t\t\t\tSRMC CTG REPORT\n\n")
            f.write("Name : {}\tAge : {}\t id no : {}\t Date and time : {}\n\n".format(self.patient_name, "TBD",
                                                                                       self.patient_id,
                                                                                       self.Date + " & " + self.Time))
            f.write("1.Baseline Heart Rate: %s\n\n" % (math.floor(self.avg_mean)))
            if self.min_value > self.max_value:
                f.write("2.Baseline Variability: %s\n\n" % (str(self.max_value) + "-" + str(self.min_value)))
            else:
                f.write("2.Baseline Variability: %s\n\n" % (str(self.min_value) + "-" + str(self.max_value)))
            f.write("3.Accelerations : %s\n\n" % self.Acc_total_count)
            f.write("4.Decelerations: %s\n\n" % self.Dec_total_count)
            f.write("5.Montevideo units: ")
            for value in range(len(self.Montevideo_list) - 1):
                f.write("{} MVU, ".format(self.Montevideo_list[value]))
            f.write("{} MVU\n\n".format(self.Montevideo_list[-1]))
            f.write("REPORT:\n%s" % self.Report_Ctg)

    @staticmethod
    def text_to_pdf(text, file_name):
        a4_width_mm = 210
        pt_to_mm = 0.35
        fontsize_pt = 10
        fontsize_mm = fontsize_pt * pt_to_mm
        margin_bottom_mm = 10
        character_width_mm = 7 * pt_to_mm
        width_text = a4_width_mm / character_width_mm

        pdf = FPDF(orientation='P', unit='mm', format='A4')
        pdf.set_auto_page_break(True, margin=margin_bottom_mm)
        pdf.add_page()
        pdf.set_font(family='Courier', size=fontsize_pt)
        splitted = text.split('\n')

        for line in splitted:
            lines = textwrap.wrap(line, int(width_text))

            if len(lines) == 0:
                pdf.ln()

            for wrap in lines:
                pdf.cell(0, fontsize_mm, wrap, ln=1)

        pdf.output(file_name, 'F')

    def Pdf_Report(self):
        self.Test_Report()
        save_path = self.path +"\\"+"Endpoints" + "\\" + "SRMC_OUTPUT_REPORTS\\"
        completeName = os.path.join(save_path,
                                    self.patient_name + "_" + self.patient_id + "_" + self.Date + "_" + self.Time.replace(
                                        ":", ".") + "_" + self.Report_Ctg + ".pdf")

        file = open(self.text)
        text = file.read()
        file.close()
        self.text_to_pdf(text, completeName)


        try:
            with open(completeName, 'rb') as img:
                image = base64.b64encode(img.read())
                # print(type(image))
                bytarr = str(image)


            Result = completeName.split("\\")[-1]
            result = Result.split("_")[-1]
            RESULT = result.split(".")[0]
            patient_name = Result.split("_")[0]
            patient_id = Result.split("_")[1]
            file_exe = result.split(".")[1]
            timeStamp = str(datetime.datetime.now())

            keys = ["patientID", "patientName", "result", "fileExtension", "Bytearray", "timeStamp"]
            values = [patient_id, patient_name, RESULT, file_exe, bytarr, timeStamp]
            myDict = {k: v for (k, v) in zip(keys, values)}
            try:
                session.flush()
                db_report = models.Ctgiresults(patientId = patient_id,
                                              patientName = patient_name,
                                              result = RESULT,
                                              fileExt = file_exe,
                                              fileData = bytarr,
                                              timeStamp = timeStamp,
                                              user_id = self.user_id
                                              )
                session.add(db_report)
                session.commit()
                session.refresh(db_report)
            except:
                session.rollback()
            # file = open(self.final_report() + start_time + ".txt","rb")
            # file.close()
            # os.remove(self.final_report() + start_time + ".txt")
            return JSONResponse(
                status_code=status.HTTP_200_OK,
                content={
                    "status": "OK",
                    "statusCode": str(status.HTTP_200_OK),
                    "message": "Report generated successfully",
                    "Data": {key: val for key, val in myDict.items()}
                }
            )

        except Exception as e:
            return JSONResponse(
                status_code=status.HTTP_400_BAD_REQUEST,
                content={'message': str(e)}
            )
